#include <iostream>
#include <fstream>

#include <stdlib.h>
#include <math.h>

#if defined(WIN32)
//#  pragma comment(linker, "/subsystem:\"windows\" /entry:\"mainCRTStartup\"")
#  include "glut.h"
#  include "glext.h"
PFNGLPOINTPARAMETERFVPROC glPointParameterfv;
#elif defined(__APPLE__) || defined(MACOSX)
#  include <GLUT/glut.h>
#else
#  define GL_GLEXT_PROTOTYPES
#  include <GL/glut.h>
#endif

/*
** 
*/
static const GLfloat lightpos[] = { 0.0, 0.0, 1.0, 0.0 }; /* ֡ */
static const GLfloat lightcol[] = { 1.0, 1.0, 1.0, 1.0 }; /* ľܸ */
static const GLfloat lightamb[] = { 0.1, 0.1, 0.1, 1.0 }; /* Ķ */

/*
** ѡƥ
*/
#include "particle.h"
#include <deque>
#define MAX_PARTICLES 800
static std::deque<particle> particles;
static GLfloat psize;
static GLfloat distance[] = { 0.0, 0.0, 1.0 };

/*
** ̤ι⤵
*/
#define HEIGHT -1.0

/*
** ƥ
*/
#define TEXWIDTH  64                       /* ƥ */
#define TEXHEIGHT 64                       /* ƥι⤵ */
static const char texture[] = "ball.raw";  /* ƥե̾ */

/*
** 
*/
static void init(void)
{
#if defined(WIN32)
  glPointParameterfv =
    (PFNGLPOINTPARAMETERFVPROC)wglGetProcAddress("glPointParameterfv");
#endif

  /* ƥɤ߹ߤ˻Ȥ */
  GLubyte image[TEXHEIGHT][TEXWIDTH][4];
  
  /* ƥɤ߹ */
  std::ifstream file(texture, std::ios::in | std::ios::binary);
  if (file) {
    file.read((char *)image, sizeof image);
    file.close();
  }
  else {
    std::cerr << texture << " ޤ" << std::endl;
  }
  
  /* ƥϥХñ̤˵ͤޤƤ */
  glPixelStorei(GL_UNPACK_ALIGNMENT, 4);
  
  /* ƥ硦̾ˡλ */
  glTexParameteri(GL_TEXTURE_2D, GL_GENERATE_MIPMAP, GL_TRUE);
  glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
  glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR_MIPMAP_LINEAR);
  
  /* ƥη֤ˡλ */
  glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_CLAMP);
  glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_CLAMP);
  
  /* ƥĶ */
  glTexEnvi(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_REPLACE);
  glTexEnvi(GL_POINT_SPRITE, GL_COORD_REPLACE, GL_TRUE);
  
  /* ƥγ */
  glTexImage2D(GL_TEXTURE_2D, 0, GL_RGBA, TEXWIDTH, TEXHEIGHT, 0,
               GL_RGBA, GL_UNSIGNED_BYTE, image);

  /* եƥȤȽ̴ؿ */
  glAlphaFunc(GL_GREATER, 0.5);

  /* ΥФ礭 */
  glPointParameterfv(GL_POINT_DISTANCE_ATTENUATION, distance);

  /*  */
  glClearColor(0.3, 0.3, 1.0, 0.0);
  glEnable(GL_DEPTH_TEST);
  glDisable(GL_CULL_FACE);

  /* դ̵ˤ */
  glDisable(GL_LIGHTING);

  /* ̤ι⤵ */
  particle::height(HEIGHT);
}

/*
** 
*/
static void scene(void)
{
  /* ѡƥ */
  if (particles.size() >= MAX_PARTICLES) {
    particles.pop_back();
  }
  particle p;
  particles.push_front(p);

  /* ƥޥåԥ󥰳 */
  glEnable(GL_TEXTURE_2D);

  /* Point Sprite ͭˤ */
  glEnable(GL_POINT_SPRITE);

  /* եƥȤͭˤ */
  glEnable(GL_ALPHA_TEST);

  /* ѡƥ */
  glColor3d(1.0, 1.0, 1.0);
  glPointSize(psize);
  glBegin(GL_POINTS);
  for (std::deque<particle>::iterator ip = particles.begin();
       ip != particles.end(); ++ip) {
    glVertex3dv(ip->getPosition());
    ip->update();
  }
  glEnd();

  /* եƥȤ̵ˤ */
  glDisable(GL_ALPHA_TEST);

  /* Point Sprite ̵ˤ */
  glDisable(GL_POINT_SPRITE);

  /* ƥޥåԥ󥰽λ */
  glDisable(GL_TEXTURE_2D);
}


/****************************
** GLUT ΥХåؿ **
****************************/

#include "trackball.h" /* ȥåܡѴؿ */

static void display(void)
{
  /* ǥӥ塼Ѵν */
  glMatrixMode(GL_MODELVIEW);
  glLoadIdentity();
  
  /* ΰ֤ */
  glLightfv(GL_LIGHT0, GL_POSITION, lightpos);
  
  /* ΰưʪΤ˰ư*/
  glTranslated(0.0, 0.0, -3.0);
  
  /* ȥåܡˤž */
  glMultMatrixd(trackballRotation());
  
  /* ̥ꥢ */
  glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
  
  /*  */
  scene();
  
  /* ֥Хåե */
  glutSwapBuffers();
}

static void resize(int w, int h)
{
  /* 礭ꤹ */
  psize = w * 0.1;

  /* ȥåܡ뤹ϰ */
  trackballRegion(w, h);
  
  /* ɥΤӥ塼ݡȤˤ */
  glViewport(0, 0, w, h);
  
  /* ƩѴλ */
  glMatrixMode(GL_PROJECTION);
  
  /* ƩѴν */
  glLoadIdentity();
  gluPerspective(60.0, (double)w / (double)h, 1.0, 100.0);
}

static void idle(void)
{
  /* ̤ؤ */
  glutPostRedisplay();
}

static void mouse(int button, int state, int x, int y)
{
  switch (button) {
  case GLUT_LEFT_BUTTON:
    switch (state) {
    case GLUT_DOWN:
      /* ȥåܡ볫 */
      trackballStart(x, y);
      break;
    case GLUT_UP:
      /* ȥåܡ */
      trackballStop(x, y);
      break;
    default:
      break;
    }
    break;
    default:
      break;
  }
}

static void motion(int x, int y)
{
  /* ȥåܡư */
  trackballMotion(x, y);
}

static void keyboard(unsigned char key, int x, int y)
{
  switch (key) {
  case 'q':
  case 'Q':
  case '\033':
    /* ESC  q  Q 򥿥פ齪λ */
    exit(0);
  default:
    break;
  }
}

/*
** ᥤץ
*/
int main(int argc, char *argv[])
{
  glutInit(&argc, argv);
  glutInitDisplayMode(GLUT_RGBA | GLUT_DEPTH | GLUT_DOUBLE);
  glutCreateWindow(argv[0]);
  glutDisplayFunc(display);
  glutReshapeFunc(resize);
  glutIdleFunc(idle);
  glutMouseFunc(mouse);
  glutMotionFunc(motion);
  glutKeyboardFunc(keyboard);
  init();
  glutMainLoop();
  return 0;
}
